# The template of k33g

## How to create a "wasm rust function"

```bash
cargo new --lib heyjson
```

Add this to `Cargo.toml`:


```toml
[lib]
name = "heyjson"
path = "src/lib.rs"
crate-type =["cdylib"]

[dependencies]
serde = { version = "1.0", features = ["derive"] }
wasm-bindgen = { version = "0.2", features = ["serde-serialize"] }

```

Change `./src/libs.rs`

```rust
use wasm_bindgen::prelude::*;
use serde::{Serialize, Deserialize};

// See: https://rustwasm.github.io/wasm-bindgen/reference/arbitrary-data-with-serde.html

#[derive(Serialize, Deserialize)]
pub struct Question {
    pub text: String,
    pub author: String,
}

#[derive(Serialize, Deserialize)]
pub struct Answer {
    pub text: String,
    pub author: String,
}

#[wasm_bindgen]
pub fn handle(value: &JsValue) -> JsValue {
    // deserialize value (parameter) to question
    let question: Question = value.into_serde().unwrap();

    // serialize answer to JsValue
    let answer = Answer {
        text: String::from(format!("hello {}", question.author)),
        author: String::from("Bob"),
    };

    return JsValue::from_serde(&answer).unwrap()
}

```

```bash
cd heyjson; wasm-pack build --target nodejs 🖐🖐🖐
```

Then, the "distribution" files are located in `./heyjson/pkg`

